
#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <mem.h>

#include "cgdk.h"
#include "array.h"
#include "mouse.h"
#include "svga.h"
#include "lin.h"
#include "keyb.h"
#include "joy.h"
#include "tm.h"
#include "win.h"

//#define DEBUG

#define MOUSE_SELECTITEM 0x1001
//#define MOUSE_RESELECTITEM 0x1002
#define MOUSE_SELECTWIN 0x1003
#define MOUSE_PUSHBUTTON 0x1004
#define MOUSE_UP 0x1011
#define MOUSE_DOWN 0x1012
#define MOUSE_PGUP 0x1013
#define MOUSE_PGDOWN 0x1014
#define MOUSE_LEFT 0x1015
#define MOUSE_RIGHT 0x1016
#define MOUSE_PGLEFT 0x1017
#define MOUSE_PGRIGHT 0x1018
#define MOUSE_RIGHTBUTTON 0x1020

#define WIN_CURSORT_INPUT 0x0A0C

//#define WIN_FRAME 1
//#define WIN_NONEFRAME 0

#define WIN_setPassiveFrame(win) WIN_setFrame(win,'','','','','','')
#define WIN_setActiveFrame(win) WIN_setFrame(win,'','','','','','')
#define WIN_setNoneFrame(win) WIN_setFrame(win, 0, 0, 0, 0, 0, 0)

#define ITEM_SIZE 256
#define MAX_OPENED 256


static TWIN *WIN_active;
static TWIN **WIN_openList;

static TWIN *WIN_desktop;
static TWIN *WIN_miniHelp;
static TWIN *WIN_miniStatus;
static char **WIN_defaultMiniHelp;

static short *updateBuf;
//static void **sprUpdateBuf;
// static unsigned VideoSeg;
static char *virtualVideo;
static short *updateBuffer;
static void **sprUpdateBuffer;
static int CType;
static int CPosX,CPosY;
static void **sprPtr;

static int (*_WaitHandler) (void);

#define line -1

#define CHECKBOX 11

#define SCROLLBAR_MAXCHAR 8
#define SCROLLBAR_HORIZONTAL (256-4*SCROLLBAR_MAXCHAR)
#define SCROLLBAR_VERTICAL (256-2*SCROLLBAR_MAXCHAR)
#define BYTES_PER_CHAR 16

static char scrollBarVerticalTable [2*SCROLLBAR_MAXCHAR*BYTES_PER_CHAR] =
{
line,line,line,line,line,line,line,line,line,line,line,line,line,line,line,line,
0x00,0x00,line,line,line,line,line,line,line,line,line,line,line,line,line,line,
0x00,0x00,0x00,0x00,line,line,line,line,line,line,line,line,line,line,line,line,
0x00,0x00,0x00,0x00,0x00,0x00,line,line,line,line,line,line,line,line,line,line,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,line,line,line,line,line,line,line,line,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,line,line,line,line,line,line,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,line,line,line,line,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,line,line,

0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
line,line,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
line,line,line,line,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
line,line,line,line,line,line,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
line,line,line,line,line,line,line,line,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
line,line,line,line,line,line,line,line,line,line,0x00,0x00,0x00,0x00,0x00,0x00,
line,line,line,line,line,line,line,line,line,line,line,line,0x00,0x00,0x00,0x00,
line,line,line,line,line,line,line,line,line,line,line,line,line,line,0x00,0x00
};

static char scrollBarHorizontalTable [2*SCROLLBAR_MAXCHAR*BYTES_PER_CHAR] =
  {
    0,0,0,line,line,line,line,line,line,line,line,line,0,0,0,0,
    0,0,0,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0x7F,0,0,0,0,
    0,0,0,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F,0x3F,0,0,0,0,
    0,0,0,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0,0,0,0,
    0,0,0,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0x0F,0,0,0,0,
    0,0,0,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0,0,0,0,
    0,0,0,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0,0,0,0,
    0,0,0,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0,0,0,0,

    0,0,0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0,0,0,0,
    0,0,0,0x80,0X80,0X80,0X80,0X80,0X80,0X80,0X80,0x80,0,0,0,0,
    0,0,0,0xC0,0XC0,0XC0,0XC0,0XC0,0XC0,0XC0,0XC0,0XC0,0,0,0,0,
    0,0,0,0xE0,0XE0,0XE0,0XE0,0XE0,0XE0,0XE0,0XE0,0XE0,0,0,0,0,
    0,0,0,0xF0,0xF0,0XF0,0XF0,0XF0,0XF0,0XF0,0XF0,0XF0,0,0,0,0,
    0,0,0,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0xF8,0,0,0,0,
    0,0,0,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0,0,0,0,
    0,0,0,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0xFE,0,0,0,0};


#define col 0x81
#define box 0x3C | col

static char checkBoxTable [2*BYTES_PER_CHAR] =
  {
    line,col,col,col,col,col,col,col,col,col,col,col,col,line,0,0,
    line,col,col,col,box,box,box,box,box,box,col,col,col,line,0,0
  };


#undef col

static void scrollBarInit ()
{
  if (SVGA_graph == 0)
  {
    TM_setTextFont (scrollBarVerticalTable, SCROLLBAR_VERTICAL, 2*SCROLLBAR_MAXCHAR,16);
    TM_setTextFont (scrollBarHorizontalTable, SCROLLBAR_HORIZONTAL, 2*SCROLLBAR_MAXCHAR,16);
    TM_setTextFont (checkBoxTable, CHECKBOX, 2, 16);
  }
}

static unsigned char scrollBar (int pos, int len, int content, int contentMax, unsigned char type)
{
  int barLen;
  int poolLen;
  int barStartPos;
  int charPos;
  int barEndPos;
  int dif;
  int plus;

  if (type == SCROLLBAR_VERTICAL)
    plus = len;
  else
    plus = 0;


  if (pos == 0)
  {
    if (type == SCROLLBAR_VERTICAL)
    {
      return '';
    }
    else
      return '';
  }

  len--;

  if (pos == len)
  {
    if (type == SCROLLBAR_VERTICAL)
    {
      return '';
    }
    else
      return '';
  }

  len--;


  charPos = SCROLLBAR_MAXCHAR * (pos-1);
  barLen = (SCROLLBAR_MAXCHAR * len * len)/contentMax;
  poolLen = (SCROLLBAR_MAXCHAR * len)-barLen;

  barStartPos =  (poolLen*content)/(contentMax-(plus));
//  barStartPos = content/contentMax
  barEndPos = barStartPos+barLen;
  if ((charPos+8 <= barStartPos) || (charPos >= barStartPos+barLen))
    return type+SCROLLBAR_MAXCHAR;
  dif = barStartPos-charPos;
  if (dif >= 0)
  {
    if (dif < SCROLLBAR_MAXCHAR)
    {
      return type+dif;
    }
  }
  else
  {
    dif = -(charPos-barEndPos);
    if (dif > 0)
    {
      if (dif < SCROLLBAR_MAXCHAR)
        return type+SCROLLBAR_MAXCHAR+dif;
    }
  }
  return type;
}


static void scrollBarCreate (char *str, int len, int content, int contentMax, char type)
{
  unsigned char c;
  int i;

  for (i = 0; i < len; i++)
  {
    c = scrollBar (i, len, content, contentMax, type);
    str [i] = c;
  }
  str [i] = 0;
}

static int scrollBarLen (int len, int contentMax, int type)
{
  int slen;
  int i;
  char c;

  slen = 0;
  for (i = 1; i < len-1; i++)
  {
    c = scrollBar (i, len, 0, contentMax, type)-type;
    switch (c)
    {
      case 0:
      {
        slen += SCROLLBAR_MAXCHAR;
        break;
      }
      default:
      {
        slen += c % SCROLLBAR_MAXCHAR;
      }
    }
  }
  return slen;
}

static void scrollBarHorizontal (char *str, int len, int content, int contentMax)
{
  scrollBarCreate (str, len, content, contentMax, SCROLLBAR_HORIZONTAL);
}

static void scrollBarVertical (char *str, int len, int content, int contentMax)
{
  scrollBarCreate (str, len, content, contentMax, SCROLLBAR_VERTICAL);
}



static char TextAttr;



void WIN_redrawScreen ()
{
  #ifndef DEBUG
  int i,j, offset, x, y, l, len, width;
  short *buf = (short *) virtualVideo;

  for (i = 0; i < TM_width*TM_length; i++)
  {
    if ((buf [i] == updateBuffer [i]) && (sprPtr [i] == sprUpdateBuffer [i]))
    {
      updateBuffer [i] = 0;
    }
    else
    {
      updateBuffer [i] = buf [i];
    }
  }

  offset = 0;

  for (i = 0; i < TM_length*TM_width; i++)
  {
    if (updateBuffer [i])
    {
      j = i;
      y = i / TM_length;
      x = i % TM_length;

      len = 0;
      while (((x+len) < TM_length) && updateBuffer [j+len])
      {
        len++;
      }

      width = 0;
      do
      {
        j += TM_length;
        l = 0;

        for (l = 0; l < len; l++)
        {
          if (updateBuffer [j+l]==0)
            break;
        }
        width++;
      }
      while (len == l && (y+width) < TM_width);

      LIN_movWin_ (updateBuf+offset, 2*len,
                   ((char *)updateBuffer)+2*(x+y*TM_length), 2*TM_length,
                   2*len, width);

      LIN_movWin_ (sprUpdateBuffer+offset, 4*len,
                ((char *)sprPtr)+4*(x+y*TM_length), 4*TM_length,
                4*len, width);

      LIN_memset_ (((char *)updateBuffer)+2*(x+y*TM_length), 2*TM_length,
                   0, 2*len, width);

      TM_printBlock (updateBuf+offset, x, y, len, width, sprUpdateBuffer+offset);

      offset += len*width;

      i += len-1;
    }
  }

  memcpy (updateBuffer, virtualVideo, 2*TM_length*TM_width);
  memcpy (sprUpdateBuffer, sprPtr, TM_length*TM_width*sizeof (void *));

  TM_flush ();

  #endif
}


int WIN_strlen (const char *str)
{
  char *s;
  int len;

  s = strchr (str, '\n');
  if (s == NULL)
    len = strlen (str);
  else
    len = s-(char *)str;
  return len;
}


int WIN_insertSubWin (TWIN *win, TWIN *subWin)
{
  if (win && subWin)
  {
    subWin->x += win->x;
    subWin->y += win->y;
    subWin->owner = win;
    if (subWin->frame)
      WIN_setPassiveFrame (subWin);
    return AL_insert ((long *)win->subWin, (long)subWin, MAX_SUBWIN);
  }
  return -1;
}

int WIN_deleteSubWin (TWIN *win, TWIN *subWin)
{
  if (win && subWin)
  {
    subWin->x -= win->x;
    subWin->y -= win->y;
    subWin->owner = NULL;
    return AL_delete ((long *)win->subWin, (long) subWin, MAX_SUBWIN);
  }
  return -1;
}

int WIN_findSubWin (TWIN *win, int n)
{
  if (win)
  {
    return AL_findNum ((long *)win->subWin, n, MAX_SUBWIN);
  }
  return -1;
}

int WIN_waitHandler (void)
{
  int i;

  MOUSE_updateCursor ();
  TM_updateCursor ();
  SVGA_update (1);

  if (_WaitHandler != NULL)
  {
    return _WaitHandler ();
  }
  return 0;
}

extern "C" void WIN_setWaitHandler ( int (*Handler) (void))
{
  _WaitHandler = Handler;
}

static int mouseX (void)
{
  if (SVGA_graph)
  {
    return MOUSE_info.x;
  }
  else
    return MOUSE_info.x*TM_clength+TM_clength/2;
}

static int mouseY (void)
{
  if (SVGA_graph)
  {
    return MOUSE_info.y;
  }
  else
    return MOUSE_info.y*TM_cwidth+TM_cwidth/2;
}

static int cmouseX (void)
{
  if (SVGA_graph)
  {
    return MOUSE_info.x/TM_clength;
  }
  else
    return MOUSE_info.x;
}

static int cmouseY (void)
{
  if (SVGA_graph)
  {
    return MOUSE_info.y/TM_cwidth;
  }
  else
    return MOUSE_info.y;
}

static int mouseXOff (void)
{
  if (SVGA_graph)
    return (MOUSE_info.x % TM_clength) % TM_clength;
  else
    return TM_clength/2;
}

static int mouseYOff (void)
{
  if (SVGA_graph)
    return (MOUSE_info.y % TM_cwidth) % TM_width;
  else
    return TM_width/2;
}

static int mouseIn (TWIN *win)
{
  return ((cmouseX() >= win->x+win->frame) && (cmouseX() <= win->x + win->csizeX) &&
     (cmouseY() >= win->y+win->frame) && (cmouseY() <= win->y + win->csizeY));
}

static int mouseSelect (TWIN *win)
{
  int content;
  int desclen;
  char newline;
  int len;

  if (mouseIn (win))
  {
    content = win->contentStart+cmouseY () - win->y - win->frame;
    switch (win->content [content].type)
    {
      case WIN_ITEMT_CHECKBOX:
      {
        len = 1;
        break;
      }
      case WIN_ITEMT_INPUT:
      case WIN_ITEMT_INPUT2:
      {
        len = win->content [content].maxLen;
        break;
      }
      default:
      {
        len = strlen (win->content [content].item);
        break;
      }
    }
    desclen = win->x+win->frame+2*win->scrollBar+
              strlen (win->content [content].desc);
    newline = strchr (win->content [content].item, '\n') != NULL;
    if ((cmouseX () >= desclen) && (
        (cmouseX () < desclen+len) || (newline) ))
    {
      if (win->content [content].type != WIN_ITEMT_COMMENT)
      {
        return content;
      }
    }
  }
  return -1;
}



static void mouseDragVertical (TWIN *win)
{
  int dif;
  int max;
  int base;
  int pos;
  int shift;
  int contentBase;
  int contentCur;

  contentCur = win->contentCur-win->contentStart;
  base = mouseY()-TM_cwidth*(win->y+win->frame+1);
  max = TM_cwidth*(win->csizeY-2)-scrollBarLen (win->csizeY, win->contentCount, SCROLLBAR_VERTICAL);
  contentBase = win->contentStart;

  while (MOUSE_info.buttons.left)
  {
    pos = mouseY()-TM_cwidth*(win->y+win->frame+1);

    dif = pos-base;
    win->contentStart = contentBase+(dif * (win->contentCount-win->csizeY))/max;
    if (win->contentStart < 0)
      win->contentStart = 0;
    if (win->contentStart > (win->contentCount-win->csizeY))
      win->contentStart = win->contentCount-win->csizeY;
    win->contentCur = win->contentStart+contentCur;

    WIN_show (win);
    MOUSE_updateCursor ();
    WIN_redrawScreen ();//ok

//    WIN_waitHandler ();
  }
}


static int mouseScrollVertical (TWIN *win, int scroll)
{
  int dif;
  int i;
  char c;

  if (win->contentCount > win->csizeY)
  {
    if ((win->scrollBar) && (cmouseX() == win->x+win->frame))
    {
      dif = cmouseY() - (win->y+win->frame);
      c = scrollBar (dif, win->csizeY, win->contentStart, win->contentCount, SCROLLBAR_VERTICAL);

      switch (c)
      {
        case '':
          return MOUSE_UP;
        case '':
          return MOUSE_DOWN;
        default:
        {
          c -= SCROLLBAR_VERTICAL;
//        if (c == SCROLLBAR_MAXCHAR)
//        {
//          mouseDragVertical (win);
//          break;
//        }
          if (c*(TM_cwidth/SCROLLBAR_MAXCHAR) < SCROLLBAR_MAXCHAR)
          {
            if (c > mouseYOff ())
              return MOUSE_PGUP;
            else
            {
              if (!scroll)
                mouseDragVertical (win);
              break;
            }
          }
          if (c > SCROLLBAR_MAXCHAR)
          {
            if ( ((c-SCROLLBAR_MAXCHAR)*(TM_cwidth/SCROLLBAR_MAXCHAR)) <mouseYOff ())
              return MOUSE_PGDOWN;
            else
            {
              if (!scroll)
                mouseDragVertical (win);
              break;
            }
          }
          for (i = 1; i < dif; i++)
          {
            if (scrollBar (i, win->csizeY, win->contentStart, win->contentCount,SCROLLBAR_VERTICAL) != SCROLLBAR_VERTICAL+SCROLLBAR_MAXCHAR)
            {
              return MOUSE_PGDOWN;
            }
          }
          return MOUSE_PGUP;
        }
      }
    }
  }
  return 0;
}

static void mouseDragHorizontal (TWIN *win)
{
  int dif;
  int max;
  int base;
  int pos;
  int shift;
  int contentBase;
  int content;
  int contentNew;
  int descLen;
  int len;

  content = win->contentCur;
  descLen = win->x+win->frame+2*win->scrollBar+strlen (win->content [content].desc);
  len = strlen (win->content [content].item)-2;

  base = mouseX()-TM_clength*descLen+1;
  max = TM_clength*(len)-
        scrollBarLen (len+2, win->content [content].maxLen,SCROLLBAR_HORIZONTAL);
  contentBase = win->content [content].curPos;//len+2

  while (MOUSE_info.buttons.left)
  {
    pos = mouseX()-TM_clength*descLen;
    dif = pos-base;

    contentNew = contentBase+(dif * (win->content [content].maxLen))/max;
    if (contentNew < 0)
      contentNew = 0;
    if (contentNew > win->content [content].maxLen)//=
      contentNew = win->content [content].maxLen;//-1

    win->content [content].curPos = contentNew;
    WIN_show (win);
    MOUSE_updateCursor ();
    WIN_redrawScreen ();//ok

//    WIN_waitHandler ();
  }
}


static int mouseScrollHorizontal (TWIN *win, int scroll)
{
  int dif;
  int i;
  char c;
  int descLen;
  int content;
  int len;

  content = win->contentCur;

  if (mouseSelect (win) == content)
  {
    descLen = win->x+win->frame+2*win->scrollBar+strlen (win->content [content].desc);
    dif = cmouseX () - descLen;
    len = strlen (win->content [content].item);
    // vertical scroll bar selected
    if (dif >= 0 && dif < len)
    {
      c = scrollBar (dif, len, win->content [content].curPos, win->content [content].maxLen, SCROLLBAR_HORIZONTAL);

      switch (c)
      {
        case '':
          return MOUSE_LEFT;
        case '':
          return MOUSE_RIGHT;
        default:
        {
            c -= SCROLLBAR_HORIZONTAL;
  //      if (c == SCROLLBAR_MAXCHAR)
  //      {
  //        mouseDragHorizontal (win);
  //        break;
  //      }

            if (c*(TM_clength/SCROLLBAR_MAXCHAR) < SCROLLBAR_MAXCHAR)
            {
              if (c > mouseXOff ())
                return MOUSE_PGLEFT;
              else
              {
                if (!scroll)
                mouseDragHorizontal (win);
              }
            }
            if (c > SCROLLBAR_MAXCHAR)
            {
              if ( ((c-SCROLLBAR_MAXCHAR)*(TM_clength/SCROLLBAR_MAXCHAR)) <mouseXOff ())
                return MOUSE_PGRIGHT;
              else
              {
                if (!scroll)
                mouseDragHorizontal (win);
              }
            }
            for (i = 1; i < dif; i++)
            {
              if (scrollBar (i, len, win->content [content].curPos,
                 win->content [content].maxLen,SCROLLBAR_HORIZONTAL) != SCROLLBAR_HORIZONTAL+SCROLLBAR_MAXCHAR)
              {
                return MOUSE_PGRIGHT;
              }
            }
            return MOUSE_PGLEFT;
        }
      }
    }
  }
  return 0;
}

void WIN_changeActive (TWIN *master, TWIN *newActive)
{
  TWIN *oldActive;
  int m = 0;

  if (newActive)
  {
    if (!master)
      m = 1;
    else
    {
      if (!master->frame)
        m = 1;
    }

    if (newActive != WIN_active)
    {
      if ((m) && (WIN_active->frame))
        WIN_setPassiveFrame (WIN_active);

      oldActive = WIN_active;
      WIN_active = newActive;

      if ((m) && (WIN_active->frame))
        WIN_setActiveFrame (WIN_active);

      WIN_printContent (oldActive, 0);
    }
  }
}


static int WinMouse (TWIN *win)
{
  int subWinNum;
  TWIN *newActive;
  int mscroll, mscroll_;
  int i;
//  int mselect;
  int content;
  int curPos;
  int oldContent;
  int waitResult;

  if (MOUSE_installed == MOUSE_INSTALLED)
  {
    if (MOUSE_info.buttons.left)
    {
//      oldActive = WIN_active;
      // find first matching window
      i = 0;
      do
      {
        subWinNum = WIN_findSubWin (win, i);
        if (subWinNum == -1)
        {
          newActive = win;
        }
        else
        {
          newActive = win->subWin [subWinNum];
        }
        i++;

        if (mouseIn (newActive))
        {
          // selection services
          content = mouseSelect (newActive);
          WIN_changeActive (NULL, newActive);

          // vertical scroll bar selected
          mscroll = mouseScrollVertical (newActive,0);

          if (mscroll)
          {
            WIN_changeActive (NULL, newActive);
            while (MOUSE_info.buttons.left)
            {
              if (mscroll == mouseScrollVertical (newActive,mscroll))
              {
                switch (mscroll)
                {
                  case MOUSE_UP:
                  {
                    newActive->scrollBarSelect = 1;
                    break;
                  }
                  case MOUSE_DOWN:
                  {
                    newActive->scrollBarSelect = 2;
                    break;
                  }
                  default:
                  {
                    newActive->scrollBarSelect = 3;
                    break;
                  }
                }
              }
              else
                newActive->scrollBarSelect = 0;

              WIN_show (newActive);
              WIN_redrawScreen ();//(ok)

              waitResult = WIN_waitHandler ();
              if (waitResult)
                return waitResult;
            }
            newActive->scrollBarSelect = 0;
            WIN_show (newActive);
            WIN_redrawScreen ();//(ok)//

            mscroll_ = mouseScrollVertical (newActive,mscroll);
            if (mscroll == mscroll_)
            {
              return mscroll;
            }
          }
          else
          {

            if (content != -1)
            {
              oldContent = newActive->contentCur;
              newActive->contentCur = content;
              if (subWinNum != win->subWinActive)
              {
                win->subWinActive = subWinNum;
                WIN_show (newActive);
                WIN_redrawScreen ();//ok//

              }

              switch (newActive->content [content].type)
              {
                case WIN_ITEMT_SCROLLBAR:
                {
                  mscroll = mouseScrollHorizontal (newActive,0);

                  if (mscroll)
                  {
                    while (MOUSE_info.buttons.left)
                    {
                      if (mscroll == mouseScrollHorizontal (newActive,mscroll))
                      {
                        switch (mscroll)
                        {
                          case MOUSE_LEFT:
                          {
                            newActive->content [content].scrollBarSelect = 1;
                            break;
                          }
                          case MOUSE_RIGHT:
                          {
                            newActive->content [content].scrollBarSelect = 2;
                            break;
                          }
                          default:
                          {
                            newActive->content [content].scrollBarSelect = 3;
                            break;
                          }
                        }
                      }
                      else
                        newActive->content [content].scrollBarSelect = 0;

                      WIN_show (newActive);
                      WIN_redrawScreen ();//ok//

                      waitResult = WIN_waitHandler ();
                      if (waitResult)
                        return waitResult;
                    }
                    newActive->content [content].scrollBarSelect = 0;
                    WIN_show (newActive);
                    WIN_redrawScreen ();//ok//

                    mscroll_ = mouseScrollHorizontal (newActive,mscroll);
                    if (mscroll == mscroll_)
                      return mscroll;
                  }
                  break;
                }
                case WIN_ITEMT_CHECKBOX:
                case WIN_ITEMT_BUTTON:
                {
                  curPos = newActive->content [content].curPos;

                  while (MOUSE_info.buttons.left)
                  {
                    if (mouseSelect (newActive) == newActive->contentCur)
                    {
                      newActive->content [content].curPos = !curPos;
                      newActive->buttonPressed = 1;
                    }
                    else
                    {
                      newActive->buttonPressed = 0;
                      newActive->content [content].curPos = curPos;

                    }
                    WIN_show (newActive);
                    WIN_redrawScreen ();//ok//

                    waitResult = WIN_waitHandler ();
                    if (waitResult)
                      return waitResult;
                  }

                  if (newActive->buttonPressed)
                  {
                    newActive->buttonPressed = 0;
//                  WIN_show (newActive);
//                  WIN_redrawScreen ();
                    newActive->content [content].curPos = curPos;
                    return MOUSE_PUSHBUTTON;
                  }
                  newActive->content [content].curPos = curPos;
                  break;
                }

                case WIN_ITEMT_INPUT:
                {
                  while (MOUSE_info.buttons.left)
                  {
                    waitResult = WIN_waitHandler ();
                    if (waitResult)
                      return waitResult;
//                    SVGA_update (1);
                  }
                  return MOUSE_PUSHBUTTON;

                }
                case WIN_ITEMT_LIST:
                {
                  WIN_show (newActive);
                  WIN_redrawScreen ();//ok//

                  while (MOUSE_info.buttons.left)
                  {
                    waitResult = WIN_waitHandler ();
                    if (waitResult)
                      return waitResult;
//                    SVGA_update (1);
                  }
                  return MOUSE_SELECTITEM;
                }
		case WIN_ITEMT_MENU:
                {
                  WIN_show (newActive);
                  WIN_redrawScreen ();//ok//

                  while (MOUSE_info.buttons.left)
                  {
                    waitResult = WIN_waitHandler ();
                    if (waitResult)
                      return waitResult;
//                    SVGA_update (1);
                  }
                  if (oldContent == content)
                  {
                    return MOUSE_PUSHBUTTON;
                  }
                  return MOUSE_SELECTITEM;
                }
                default:
                {
                  WIN_show (newActive);
                  WIN_redrawScreen ();

                  while (MOUSE_info.buttons.left)
                  {
                    waitResult = WIN_waitHandler ();
                    if (waitResult)
                      return waitResult;
//                  SVGA_update (1);
                  }
                  return MOUSE_SELECTITEM;
                }
              }

              return MOUSE_SELECTITEM;
            }
            else
            {
              while (MOUSE_info.buttons.left)
              {
                waitResult = WIN_waitHandler ();
                if (waitResult)
                  return waitResult;
//                SVGA_update (1);
              }
            }
          }
          return MOUSE_SELECTITEM;
        }
      }
      while ((subWinNum != -1) && (i < MAX_SUBWIN));

      while (MOUSE_info.buttons.left)
      {
        WIN_waitHandler ();
        waitResult = WIN_waitHandler ();
        if (waitResult)
          return waitResult;
//        SVGA_update (1);
      }
    }
    if (MOUSE_info.buttons.right)
    {
      while (MOUSE_info.buttons.right)
      {
        waitResult = WIN_waitHandler ();
        if (waitResult)
          return waitResult;
//        SVGA_update (1);
      }
      return MOUSE_RIGHTBUTTON;
    }
    MOUSE_updateCursor ();
  }
  return 0;
}

static int JoyLast = -1;

static int WIN_joy (void)
{
  int exitCode = 0;

  if (JOY_calibratedA)
  {
    JOY_read ();

    switch (JOY_positionA ())
    {
      case JOY_UP:
      {
        exitCode = KEY_UP;
        break;
      }
      case JOY_DOWN:
      {
        exitCode = KEY_DOWN;
        break;
      }
      case JOY_LEFT:
      {
        exitCode = KEY_LEFT;
        break;
      }
      case JOY_RIGHT:
      {
        exitCode = KEY_RIGHT;
        break;
      }
    }
    if (JOY_state.a.button1)
    {
      exitCode = KEY_ENTER;
    }
    if (JOY_state.a.button2)
    {
      exitCode = KEY_TAB;
    }
    if (exitCode == JoyLast)
    {
      exitCode = 0;
    }
    else
    {
      JoyLast = exitCode;
    }
  }
  return exitCode;
}

int WIN_getEvent (TWIN *win)
{
  int c;

  c = WIN_waitHandler ();
  if (c)
    return c;

  c = KEYB_key (KEYB_get ());
  if (!c)
  {
    c = WIN_joy ();
    if (!c)
    {
      c = WinMouse (win);
    }
  }
  return c;
}

int WIN_waitEvent (TWIN *win)
{
  int event;

  do
  {
    event = WIN_getEvent (win);
  }
  while (event == 0);

  return event;
}


void WIN_delete (TWIN *win)
{
  if (win != NULL)
  {
    if (win->sprBuf)
      _free (win->sprBuf);
    if (win->sprSavePtr)
      _free (win->sprSavePtr);
    if (win->sprPtr)
    {
      _free (win->sprPtr);
    }
    delete win->content;
    delete win;
  }
}


int WIN_newItem (TWIN *win, int item, int type,
                 char *desc, char *Str, int value,
                 char *miniStatus, int maxLen)
{
  if (win != NULL)
  {
    if (item < win->contentMax)
    {
//      if (win->content [i].type == 0)
      {
        win->content [item].type = type;
        win->content [item].miniStatus = miniStatus;
        win->content [item].maxLen = maxLen;
        win->content [item].step = 1;
        win->content [item].curPos = 0;
        win->content [item].pageStep = 2;
        if (value == -1)
        {
          value = item;
        }
        win->content [item].value = value;
	if (Str == NULL)
        {
          strcpy (win->content [item].item, "");
        }
        else
        {
          memcpy (win->content [item].item, Str, ITEM_SIZE);
        }
        if (desc == NULL)
          strcpy (win->content [item].desc, "");
        else
          strcpy (win->content [item].desc, desc);
        if (maxLen == -1)
	{
	  if (win->frame)
	    maxLen = 0;

	  maxLen += win->csizeX - 2*win->frame-
				strlen(win->content [item].desc)-1;
	  win->content [item].maxLen = maxLen;
        }
        win->contentCount++;
        return item;
      }
    }
  }
  return -1;
}

int WIN_changeItem (TWIN *win, int item, char *itemStr)
{
  int i = item;

  if (win != NULL)
  {
    if (i < win->contentMax)
    {
      if (win->content [i].type != 0)
      {
        if (itemStr == NULL)
          strcpy (win->content [i].item, "");
        else
          memcpy (win->content [i].item, itemStr, ITEM_SIZE);
        return i;
      }
    }
  }
  return -1;
}

int WIN_changeItemType (TWIN *win, int item, int type)
{
  if (win != NULL)
  {
    if (item < win->contentMax)
    {
      if (win->content [item].type != 0)
      {
        win->content [item].type = type;
      }
      return item;
    }
  }
  return 0;
}


// item == 0 ->insert to begin
// item == -1->insert to end
int WIN_insertItem (TWIN *win, int item, int itemtype,
                    char *desc, char *itemStr, int value,
                    char *miniStatus, int maxLen)
{
  int i = 0;

  if (win != NULL)
  {
    if (win->contentCount >= win->contentMax)
    {
      WIN_deleteItem (win, 0);
      win->contentCur--;
      win->contentStart--;
    }

    if (item == -1)
    {
      item = win->contentCount;
    }

    if (item < win->contentMax)
    {
      for (i = win->contentCount; i > item; i--)
      {
        win->content [i] = win->content [i-1];
      }
      WIN_newItem (win, item, itemtype, desc, itemStr, value, miniStatus, maxLen);
//      if (Item <= win->contentCur)
//        win->contentCur++;
      return item;
    }
  }
  return -1;
}

int WIN_appendItem (TWIN *win, int itemType, char *desc, char *itemStr,
                    int value, char *miniStatus, int maxLen)
{
  return WIN_insertItem (win, -1, itemType, desc, itemStr, value, miniStatus,
                         maxLen);
}

int WIN_appendButton (TWIN *win, char *desc, char *itemStr, int value,
                      char *miniStatus, int maxLen)
{
  return WIN_insertItem (win, -1, WIN_ITEMT_BUTTON, desc, itemStr, value,
                         miniStatus, maxLen);
}

int WIN_appendMenu (TWIN *win, char *desc, char *itemStr, int value,
                      char *miniStatus, int maxLen)
{
  return WIN_insertItem (win, -1, WIN_ITEMT_MENU, desc, itemStr, value,
                         miniStatus, maxLen);
}

int WIN_appendList (TWIN *win, char *desc, char *itemStr, int value,
                      char *miniStatus, int maxLen)
{
  return WIN_insertItem (win, -1, WIN_ITEMT_LIST, desc, itemStr, value,
                         miniStatus, maxLen);
}

int WIN_appendCheckBox (TWIN *win, char *desc, char *itemStr, int value,
                      char *miniStatus, int maxLen)
{
  return WIN_insertItem (win, -1, WIN_ITEMT_CHECKBOX, desc, itemStr, value,
                         miniStatus, maxLen);
}

int WIN_appendComment (TWIN *win, char *itemStr)
{
  return WIN_insertItem (win, -1, WIN_ITEMT_COMMENT, NULL, itemStr, -1, NULL, -1);
}


void WIN_deleteItem (TWIN *win, int item)
{
  int i;

  if (win != NULL)
  {
    for (i = item; i < win->contentCount; i++)
    {
      win->content [i] = win->content [i+1];
    }
    win->contentCount--;
    if ((win->contentStart < item) && ((win->contentStart+win->csizeY) > item))
    {
      if (win->contentStart)
        win->contentStart--;
    }
    if (item == win->contentCur)
    {
      if (item > 0)
        win->contentCur--;
      else
        win->contentCur++;
      WIN_updateHumble (win,1);
    }
  }
}



void WIN_setBounds (TWIN *win, int x, int y, int size_x, int size_y)
{
  win->sizeX = size_x;
  win->sizeY = size_y;
  win->csizeX = size_x-2*win->frame;
  win->csizeY = size_y-2*win->frame;

  if (x == W_CENTER)
  {
    x = (TM_length-(win->csizeX+win->frame*2))/2;
  }
  if (y == W_CENTER)
  {
    y = (TM_width-(win->csizeY+win->frame))/2;
  }

  win->x = x;
  win->y = y;
}


void WIN_scrollBarEnable (TWIN *win)
{
  win->scrollBar = 1;
}

void WIN_scrollBarDisable (TWIN *win)
{
  win->scrollBar = 0;
}

void WIN_setColors (TWIN *win, int content_C,
                    int select_C, int highlight_C,
                    int item_C,
                    int selectPassive_C,
                    int ActiveFrame_C, int PassiveFrame_C)
{
  if (PassiveFrame_C == -1)
    PassiveFrame_C = content_C;
  if (ActiveFrame_C == -1)
    ActiveFrame_C = content_C;
  if (select_C == -1)
    select_C = content_C;
  if (highlight_C == -1)
    highlight_C = content_C;
  if (item_C == -1)
    item_C = content_C;
  if (selectPassive_C == -1)
    selectPassive_C = select_C;

  if (win != NULL)
  {
    win-> color. frameActive = ActiveFrame_C;
    win-> color. framePassive = PassiveFrame_C;
    win-> color. content = content_C;
    win-> color. select = select_C;
    win-> color. selectPassive = selectPassive_C;
    win-> color. highlight = highlight_C;
    win-> color. item = item_C;
  }
}

void WIN_setTitle (TWIN *win, const char *Title)
{
  if (win != NULL)
  {
    strncpy (win->title, Title, sizeof win->title);
  }
}










static int Putch (int X, int Y, unsigned char Ch)
{
  unsigned Word;
  int pos;
  Word = (TextAttr << 8) + Ch;
  pos = X+ Y*TM_length;
  if ((X < TM_length) && (Y < TM_width))
  *(((unsigned short *) virtualVideo) + pos) = Word;

//  if (KEYB_rctrl)
//    WIN_redrawScreen ();

  return 0;
}

static int Cputs (int X, int Y, const char *str)
{
  int i;
  char c;
  int x = X;
  int y = Y;

  for (i = 0; i < strlen (str); i++)
  {
    c = str [i];
    switch (c)
    {
      default:
      {
        Putch (x, y, c);
        x++;
        break;
      }
    }
  }
  return 0;
}


void WIN_cls (TWIN *win)
{
  int I, J;

  TextAttr = win->color.content;

  for (I = 0; I < win->csizeX; I++)
  {
    for (J = 0; J < win->csizeY; J++)
    {
      Putch (win->x+I+win->frame, win->y+J+win->frame, win->BGChar);
    }
  }
}

//void WIN_setEnableCommands (TWIN *win, TWINCom comms)
//{
//  if (win != NULL)
//  {
//    win->commsAvail = comms;
//  }
//}
//

int WIN_init (void)
{
  if (!virtualVideo)
  {
    if (TM_install () == 0)
    {
//      _atexit (WIN_done);
      KEYB_init ();

      CType = TM_getCursorType ();
      TM_getCursorPos (&CPosX, &CPosY);
      TM_setCursorType (TM_NOCURSOR);

      if (WIN_openList == NULL)
      {
        WIN_openList = (TWIN * *) _alloc (sizeof (TWIN *) * MAX_OPENED);

        if (WIN_openList == NULL)
        {
          return 1;
        }
      }

      memset (WIN_openList, 0, sizeof (TWIN *) * MAX_OPENED);

      scrollBarInit ();

      #ifndef DEBUG
      // alloc virtual video
      if (virtualVideo == NULL)
      {
        virtualVideo =(char *) _alloc (TM_length*TM_width*sizeof (short));

        if (virtualVideo == NULL)
        {
          return 1;
        }
      }


      // alloc updateBuffer
      if (updateBuffer == NULL)
      {
        updateBuffer = (short *) _alloc (TM_length*TM_width*sizeof (short));

        if (updateBuffer == NULL)
        {
          _free (virtualVideo);
          virtualVideo = NULL;
          return 1;
        }
      }
      memset (updateBuffer, 0, TM_length*TM_width*sizeof (short));

      // alloc sprUpdateBuffer
      if (sprUpdateBuffer == NULL)
      {
        sprUpdateBuffer = (void * *) _alloc (TM_length*TM_width*sizeof (void *));

        if (sprUpdateBuffer == NULL)
        {
          _free (virtualVideo);
          virtualVideo = NULL;

          _free (updateBuffer);
          updateBuffer = NULL;
          return 1;
        }
      }
      memset (sprUpdateBuffer, 0, TM_length*TM_width*sizeof (void *));

      // alloc updateBuf
      if (updateBuf == NULL)
      {
        updateBuf = (short *) _alloc (TM_length*TM_width*sizeof (short));

        if (updateBuf == NULL)
        {
          _free (virtualVideo);
          virtualVideo = NULL;

          _free (updateBuffer);
          updateBuffer = NULL;

          _free (sprUpdateBuffer);
          sprUpdateBuffer = NULL;

          return 1;
        }
      }

      // alloc sprPtr
      if (sprPtr == NULL)
      {
        sprPtr = (void * *) _alloc (TM_length*TM_width*sizeof (void *));

        if (sprPtr == NULL)
        {
          _free (virtualVideo);
          virtualVideo = NULL;

          _free (updateBuffer);
          updateBuffer = NULL;

          _free (sprUpdateBuffer);
          updateBuffer = NULL;

          _free (updateBuf);
          updateBuf = NULL;

          return 1;
        }
      }
      memset (sprPtr, 0, TM_length*TM_width*sizeof (void *));

      #else
      virtualVideo = (char *) MK_DP (VideoSeg, 0);
      #endif
      return 0;
    }
    else
    {
      return 2;
    }
  }
  else
  {
    return 3;
  }
}

void WIN_done (void)
{
  if (WIN_openList)
  {
    _free (WIN_openList);
    WIN_openList = NULL;
  }

  #ifndef DEBUG
  if (virtualVideo)
  {
    _free  (virtualVideo);
    virtualVideo = NULL;
  }

  if (updateBuffer)
  {
    _free (updateBuffer);
    updateBuffer = NULL;
  }

  if (sprUpdateBuffer)
  {
    _free (sprUpdateBuffer);
    sprUpdateBuffer = NULL;
  }

  if (updateBuf)
  {
    _free (updateBuf);
    updateBuf = NULL;
  }

  #endif
}

//
//void WIN_setBG (char Char, char color)
//{
//  int I, J;
//
//  TextAttr = color;
//  for (I = 0; I <  TM_length; I++)
//  {
//    for (J = 0; J <  TM_width; J++)
//    Putch (I, J, Char);
//  }
//}
//

//void WIN_setBG (TWIN *win, char Char)
//{
//  win->BGChar = Char;
//}


static void SetAttr (int X, int Y, char Attr)
{
  if ((X < TM_length) && (Y < TM_width))
  {
    int A = 2*(X+Y*TM_length);
    *(((char *) virtualVideo)+A+1) = Attr;
  }
}

static void putRect (TWIN *win, void *Dest)
{
  int I;
  char *VBuf = virtualVideo+ 2*(win->x+win->y*TM_length);
  char *Buf = (char *) Dest;
  int Size;

  Size = 2*win->csizeX+4*win->frame;

  for (I = 0; I < win->csizeY+2*win->frame; I++)
  {
    memcpy (VBuf, Buf, Size);
    if (win->frame)
    {
      VBuf [Size+1] = Buf [Size+1];
      VBuf [Size+3] = Buf [Size+3];
    }
    Buf += Size + 4*win->frame;
    VBuf += 2*TM_length;
  }
  if (win->frame)
  {
    for (I = 0; I < win->csizeX+2; I++)
    {
      VBuf [2*(2+I) + 1] = Buf [2*(2+I) + 1];
    }
  }
}

static void getRect (TWIN *win, void *Dest)
{
  int I;
  char *VBuf, *Buf;
  int Size;

  Buf = (char *) Dest;
  VBuf = virtualVideo+ 2*(win->x+win->y*TM_length);
  Size = win->csizeX+4*win->frame;
  Size += Size;

  for (I = 0; I < win->csizeY+3*win->frame; I++)
  {
    memcpy (Buf, VBuf, Size);
    Buf += Size;
    VBuf += 2*TM_length;
  }

}


void WIN_putRect (TWIN *win)
{
  putRect (win, win->videoBuf);
}

void WIN_putSaveRect (TWIN *win)
{
  putRect (win, win->saveBuf);
}


void WIN_getRect (TWIN *win)
{
  getRect (win,win->videoBuf);
}

void WIN_getSaveRect (TWIN *win)
{
  getRect (win,win->saveBuf);
}


void WIN_setFrame (TWIN *win, char C0, char C1, char C2, char C3, char C4, char C5)
{
  if (win != NULL)
  {
    if (C0 != 0)
    {
      win->frame = 1;
      win->frameChar [0] = C0;
      win->frameChar [1] = C1;
      win->frameChar [2] = C2;
      win->frameChar [3] = C3;
      win->frameChar [4] = C4;
      win->frameChar [5] = C5;
    }
    else
    {
      win->frame = WIN_NONEFRAME;
    }
  }
}


void WIN_setCursorPos (TWIN *win)
{
  int desclen = strlen (win->content [win->contentCur].desc);
  int X = win->content [win->contentCur].curPos;
  int Y = win->contentCur - win->contentStart;
  TM_setCursorPos (win->x + 2*win->scrollBar + desclen +X + win->frame, win->y+Y+win->frame);
}

void WIN_puts (TWIN *win, int X, int Y, const char *str, int color)
{
  int i, j;
  char c;
  int x = win->x +X + win->frame;
  int y = win->y +Y + win->frame;
  int len = 0;
  int winlen = win->csizeX - X;

  TextAttr = color;
  for (i = 0; i < strlen (str); i++)
  {
    c = str [i];
    switch (c)
    {
      case '~':
      {
        if (TextAttr == color)
          TextAttr = win->color.highlight;
        else
          TextAttr = color;
        break;
      }
      case '\n':
      case '\r':
      {
        for (j = 0; j < winlen - len; j++, x++)
          Putch (x, y, ' ');
        len = winlen;
        y++;
        x = X+win->x+win->frame;
        len = 0;
        break;
      }
      default:
      {
        if ((x-win->x) <= win->csizeX)
        {
          Putch (x, y, c);
          len++;
        }
        else
        {
          abs (x);
        }
        x++;

        break;
      }
    }
  }
}

void WIN_redrawFrame (TWIN *win)
{
#define YShadowSize 2
  int I,J;

  if (win != NULL)
  {
    if (win->frame)
    {
      TextAttr = win->color.frameActive;
      // draw the Win frame
      Putch (win->x, win->y, win->frameChar [0]);

      for (I = 1; I <=  win->csizeX ; I++)
        Putch (win->x + I, win->y, win->frameChar [4]);

      Putch (win->x + I, win->y, win->frameChar [1]);

  //    TextAttr = win->color.FrameActive;
      Cputs (win ->x + ((win->csizeX- strlen (win->title)) / 2) +1, win->y, win->title);
  //    TextAttr = win->color.content;

      for (I = 1; I <= win->csizeY; I++)
      {
        Putch (win->x, win->y+I, win->frameChar [5]);
        Putch (win->csizeX+ win->x+1, win->y+I, win->frameChar [5]);
        if (win->scrollBar)
        {
          TextAttr = win->color.content;
          Putch (win->x + 2, win->y+I, '');
          TextAttr = win->color.frameActive;
        }
        if (win->shadow)
        {
          SetAttr (win->csizeX+ win->x+2, win->y+I, TM_FONT_SHADOW );
          SetAttr (win->csizeX+ win->x+3, win->y+I, TM_FONT_SHADOW );
        }
      }

      Putch (win->x, win->y + win->csizeY+1, win->frameChar [2]);

      for (I = 1; I <= win->csizeX; I++)
      {
        Putch (win->x+I, win->y+win->csizeY+1, win->frameChar [4]);
      }
      Putch (win->x+I, win->y+win->csizeY+1, win->frameChar [3]);

      if (win->shadow)
      {
        SetAttr (win->csizeX+ win->x+2, win->y+win->csizeY+1, TM_FONT_SHADOW );
        SetAttr (win->csizeX+ win->x+3, win->y+win->csizeY+1, TM_FONT_SHADOW );

        for (I = 1; I <=  win->csizeX+2; I++)
        {
          SetAttr (win ->x+YShadowSize+I-1,win->y + win->csizeY+2, TM_FONT_SHADOW );
        }
      }
    }
  }
}


void WIN_scrollHorizontal (TWIN *win, int step)
{
  int pos;
  int maxLen;
  int contentCur;

  contentCur = win->contentCur;
  pos = win->content [contentCur].curPos;
  maxLen = win->content [contentCur].maxLen;
  win->content [contentCur].curPos+=step;

  if (step < 0)
  {
    if (pos+step < 0)
    {
      win->content [contentCur].curPos=0;
    }
  }
  else
  {
    if (pos+step > maxLen)
    {
      win->content [contentCur].curPos=maxLen;
    }
  }
}


void WIN_updateHumble (TWIN *win, int enter)
{
  int contentCur;
  char humbleItem;

  contentCur = win->contentCur;
  if (win->humbleWin)
  {
    switch (win->content [contentCur].type)
    {
      case WIN_ITEMT_MENU:
      case WIN_ITEMT_LIST:
      {
        if (win->content [contentCur].value)
        {
          strcpy (win->humbleWin->content [win->humbleItem].item,
                  win->content [contentCur].item);
        }
        else
        {
          strcpy (win->humbleWin->content [win->humbleItem].item,
                  "");
        }
        win->humbleWin->content [win->humbleItem].curPos =
          WIN_strlen (win->humbleWin->content [win->humbleItem].item);

        break;
      }

      case WIN_ITEMT_CHECKBOX:
      {
        strcpy (win->humbleWin->content [win->humbleItem].item,
                win->content [contentCur].item+
                strlen (win->content [contentCur].item)+1);
        break;
      }
      default:
      {
        strcpy (win->humbleWin->content [win->humbleItem].item,
                win->content [contentCur].item);
        break;
      }
      case WIN_ITEMT_BUTTON:
      {
        if (enter)
        {
          strcpy (win->humbleWin->content [win->humbleItem].item,
                  win->content [contentCur].item);
        }
        else
        {
          return;
        }
        break;
      }
    }
    win->humbleWin->content [win->humbleItem].value =
    win->content [contentCur].value;
//    switch (win->humbleWin->content [win->humbleItem].type)
//    {
//      case WIN_ITEMT_INPUT:
//      case WIN_ITEMT_INPUT2:
//      {
//      win->humbleWin->content [win->humbleItem].curPos =
//        WIN_strlen (win->humbleWin->content [win->humbleItem].item);
//      break;
//      }
//      default:
//      {
//      win->humbleWin->content [win->humbleItem].curPos =
//        win->content [contentCur].curPos;
//      break;
//      }
//    }
    WIN_show (win->humbleWin);
//    WIN_redrawScreen ();
  }
}



int WIN_moveEvent (TWIN *win, int event)
{
  int contentCur;

  contentCur = win->contentCur;

  if ((event == KEY_LEFT) || (event == KEY_RIGHT))
  {
    if (win->content [contentCur].type != WIN_ITEMT_SCROLLBAR)
      return 0;
  }
  switch (event)
  {
    case MOUSE_PGLEFT:
    {
      WIN_scrollHorizontal (win, -win->content [contentCur].pageStep);
      WIN_show (win);
      WIN_redrawScreen ();
      break;
    }
    case KEY_LEFT:
    case MOUSE_LEFT:
    {
      WIN_scrollHorizontal (win, -win->content [contentCur].step);
      WIN_show (win);
      WIN_redrawScreen ();
      break;
    }


    case MOUSE_PGRIGHT:
    {
      WIN_scrollHorizontal (win, win->content [contentCur].pageStep);
      WIN_show (win);
      WIN_redrawScreen ();
      break;
    }

    case KEY_RIGHT:
    case MOUSE_RIGHT:
    {
      WIN_scrollHorizontal (win, win->content [contentCur].step);
      WIN_show (win);
      WIN_redrawScreen ();
      break;
    }

    case MOUSE_UP:
    case KEY_UP   : WIN_scrollUp (win); break;
    case MOUSE_DOWN:
    case KEY_DOWN : WIN_scrollDn (win); break;
    case KEY_HOME : WIN_scrollHome (win); break;
    case KEY_END  : WIN_scrollEnd (win); break;
    case MOUSE_PGUP:
    case KEY_PGUP : WIN_scrollPageUp (win); break;
    case MOUSE_PGDOWN:
    case KEY_PGDN : WIN_scrollPageDn (win); break;
    case MOUSE_SELECTITEM:
    {
      break;
    }
    default:
    {
      return 0;
    }
  }
  WIN_updateHumble (win,0);

  return 1;
}


static int insertchar (char *str, int pos, char ch)
{
  int i;
  int len = strlen (str);

  if (pos <= len)
  {
    for (i = len+1; i > pos; i--)
      str [i] = str [i-1];
    str [pos] = ch;
    return 1;
  }
  return 0;
}

static int deletechar (char *str, int pos)
{
  int len = strlen (str);

  if ((pos < len) && (pos >= 0))
  {
    strcpy (str+pos, str+pos+1);
    return 1;
  }
  return 0;
}



int WIN_input (TWIN *win)
{
  int desclen, inputsx;
  int c = 0;
  int i;
  char abort = 0;
  int update = 0;
  int maxlen;
  int content;
  int curlen;
  int j;
  char OldStr [ITEM_SIZE];
  char *S;
  TWIN *subWin;


  #define Str subWin->content [subWin->contentCur].item
  if (win != NULL)
  {
    subWin = WIN_subWin (win);

//    TM_setCursorType (WIN_CURSORT_INPUT);

//    WIN_printContent (subWin, subWin->contentStart);
//    WIN_redrawScreen ();

    content=subWin->contentCur;

    strcpy (OldStr, Str);
//    WIN_getItem (Str, subWin,content);
    strcpy (Str, subWin->content [content].item);
    subWin->content[content].curPos = WIN_strlen (Str);
    Str [subWin->content[content].curPos] = 0;

    maxlen = subWin->content [subWin->contentCur].maxLen;
    do
    {
      WIN_setCursorPos (subWin);

      curlen = strlen (Str);
//      if (curlen == 0)
//      {
//      insertchar (Str,0,'\n');
//      curlen++;
//      WIN_printContent (subWin, subWin->contentStart);
//      WIN_redrawScreen ();
//      }

      c = WIN_waitEvent (win);

      switch (c)
      {
        case KEY_F1:
        {
          WIN_moreMiniHelp (subWin);
          WIN_printMiniHelp (subWin);
          WIN_redrawScreen ();
          break;
        }
        case KEY_TAB:
        case MOUSE_PUSHBUTTON: abort = 1; break;
        case KEY__ABORT:
        case MOUSE_RIGHTBUTTON:
        case KEY_ESC   : strcpy (Str, OldStr); abort = 1; break;
        case KEY_F10   : abort = 1; break;

        case KEY_HOME  : update = 1; subWin->content[subWin->contentCur].curPos = 0; break;
        case KEY_END   : update = 1; subWin->content[subWin->contentCur].curPos = curlen; break;
        case MOUSE_LEFT:
        case KEY_LEFT  : update = 1; if (subWin->content[subWin->contentCur].curPos > 0) subWin->content[subWin->contentCur].curPos--; break;
        case MOUSE_RIGHT:
        case KEY_RIGHT : update = 1; if (subWin->content[subWin->contentCur].curPos < curlen) subWin->content[subWin->contentCur].curPos++; break;
        case KEY_DEL   :
        {
          if (update != 0)
          {
            deletechar (Str, subWin->content[subWin->contentCur].curPos);
          }
          else
          {
            Str [0] = 0;
            subWin->content[subWin->contentCur].curPos = 0;
            curlen = 0;
	    update = 1;
	  }

	  WIN_printContent (subWin, subWin->contentStart);
	  WIN_redrawScreen ();
	  break;
        }

        case KEY_BACKSPACE:
        {
          if (update != 0)
          {
            if (deletechar (Str, subWin->content[subWin->contentCur].curPos-1))
                subWin->content[subWin->contentCur].curPos--;
          }
          else
          {
            Str [0] = 0;
            subWin->content[subWin->contentCur].curPos = 0;
            curlen = 0;
            update = 1;
          }
          WIN_printContent (subWin, subWin->contentStart);
          WIN_redrawScreen ();

          break;

        }

        case KEY_ENTER :
        {
//        if (curlen < maxlen)
//        {
//          subWin->content[subWin->contentCur].curPos++;
//        }
          abort = 1;
          break;
        }

        default:
        {
          if (WIN_moveEvent (WIN_active, c) == 0)
          {
            if (c < 0x100)
            {
              c = KEYB_ascii (c);
              if (c)
              {
                if (update == 0)
                {
                  Str [0] = 0;
                  subWin->content[subWin->contentCur].curPos = 0;
                  curlen = 0;
                  update = 1;
                }
                if (curlen <= maxlen)
                {
                  insertchar (Str, subWin->content[subWin->contentCur].curPos, c);
                  subWin->content[subWin->contentCur].curPos++;
                }
                WIN_printContent (subWin, subWin->contentStart);
                WIN_redrawScreen ();
              }
            }
          }
          c = 0;
        }
      }
    }
    while ((!abort) && (WIN_active == subWin) && (subWin->contentCur == content));

//    TM_setCursorType (TM_NOCURSOR);
  }

  return c;
  #undef Str
}



int WIN_printContent (TWIN *win, int Start)
{
  int i = 0,j;
  int comment;
  int desclen, itemlen, maxlen, xlen;
  int color, _color;
  int owstart = 0;
  int owend = 0;
  char c [256];
  char space [] = " ";

  c [1] = 0;

  owstart = AL_find ((long *)WIN_openList, (long)win, MAX_OPENED);
//  while (WIN_openList [owstart] != win)
//    owstart++;

  owend = owstart+AL_find ((long *)WIN_openList+owstart, NULL, MAX_OPENED-owstart);
  owend--;
//  if ((owstart != -1) && (owend != -1))

  Start = win->contentStart;

  if ((win->contentCur >= win->contentCount) && (win->contentCount))
    win->contentCur = win->contentCount-1;


  for (j = owend; j > owstart; j--)
  {
    WIN_getSaveRect (WIN_openList [j]);
    WIN_putRect (WIN_openList [j]);
  }

  WIN_cls (win);

//  WIN_redrawScreen ();

  WIN_redrawFrame (win);

  while ( (i+Start < win->contentCount) && (i < win->csizeY) )
  {
    // update scroll bar
    if (win->contentCount > win->csizeY)
    {
      if (win->scrollBar)
      {
        c [0] = scrollBar (i, win->csizeY, win->contentStart, win->contentCount, SCROLLBAR_VERTICAL);
        if (((i == 0) && (win->scrollBarSelect == 1)) ||
            ((i == win->csizeY-1) && (win->scrollBarSelect == 2)))
        {
	  color = win->color.frameSelect;
	}
        else
        {
          color = win->color.content;
        }
        WIN_puts (win, 0, i, c, color);
      }
    }

    desclen = 2*win->scrollBar;

    WIN_puts (win, desclen, i, win->content [i+Start].desc,
              win->color.content);

    // print description
    desclen += strlen (win->content [i+Start].desc);
    if (desclen > win->csizeX)
      desclen = win->csizeX;

    // choose color
    if ( ((i+Start) == win->contentCur) && (win->selectable))
    {
      // selected item was found
      TextAttr = win->color.content;
      if (win->buttonPressed)
      {
        color = win->color.highlight;
      }
      else
      {
        if (win == WIN_active)
        {
          color = win->color.select;
        }
        else
        {
          color = win->color.selectPassive;
        }
      }
      if (win == WIN_active)
      {
        WIN_printMiniStatus (win->content [i].miniStatus);
        WIN_setCursorPos (win);
      }

      if (win == WIN_active)
      {
        switch (win->content [i+Start].type)
        {
          case WIN_ITEMT_INPUT:
          case WIN_ITEMT_INPUT2:
          {
            TM_setCursorType (WIN_CURSORT_INPUT);
            break;
          }

	  case WIN_ITEMT_MENU:
          case WIN_ITEMT_LIST:
          case WIN_ITEMT_BUTTON:
	  case WIN_ITEMT_COMMENT:
	  {
            TM_setCursorType (TM_NOCURSOR);
          }
        }
      }
    }
    else
    {
      TextAttr = win->color.select;
      color = win->color.item;
    }



    switch (win->content [i+Start].type)
    {
      case WIN_ITEMT_COMMENT:
      {
	WIN_puts (win, desclen, i, win->content [i+Start]. item, win->color.content);
	break;
      }

      case WIN_ITEMT_INPUT:
      case WIN_ITEMT_INPUT2:
      {
	for (j = 0; j <= (win->content [i+Start].maxLen+1); j++)
	  WIN_puts (win, desclen+j, i, space, color);
      }
      case WIN_ITEMT_MENU:
      case WIN_ITEMT_LIST:
      case WIN_ITEMT_BUTTON:
      {
//        WIN_setCursorPos (win, desclen + 2*win->scrollBar+win->content [i+Start].curPos, i);
	WIN_puts (win, desclen, i, win->content [i+Start]. item, color);
	break;
      }
      case WIN_ITEMT_CHECKBOX:
      {
	c [0] = CHECKBOX + win->content [i+Start].curPos;
	WIN_puts (win, desclen, i, c, color);
	break;
      }
      case WIN_ITEMT_SCROLLBAR:
      {
        // curpos , maxlen
        for (j = 0; j < strlen (win->content [i+Start].item); j++)
        {
          c [0] = scrollBar (j, strlen (win->content [i+Start].item),
                             win->content [i+Start].curPos,
                             win->content [i+Start].maxLen, SCROLLBAR_HORIZONTAL);

          if (((j == 0) && (win->content [i+Start].scrollBarSelect == 1)) ||
              ((j == strlen (win->content [i+Start].item)-1) &&
              (win->content [i+Start].scrollBarSelect == 2)))
          {
            _color = win->color.h_barSelect;
          }
          else
          {
            _color = color;
	  }

          WIN_puts (win, desclen+j, i, c, _color);
        }
        break;
      }
    }
    i++;
  }

  for (j = owstart+1; j <= owend; j++)
  {
    WIN_getRect (WIN_openList [j]);
    WIN_putSaveRect (WIN_openList [j]);
  }

  if (win->sprPtr)
  {
    LIN_movWin (sprPtr, win->x*sizeof (void *), win->y,
                TM_length*sizeof (void *), TM_width,
		win->sprPtr, (2*win->frame+win->csizeX)*sizeof (void *),
                (2*win->frame+win->csizeX)*sizeof (void *),
                win->csizeY+2*win->frame);
  }

  return i;
}



void WIN_hide (TWIN *win)
{
  WIN_putRect (win);

  if (win->sprSavePtr)
  {
    LIN_movWin    (sprPtr, win->x*sizeof (void *), win->y,
                   TM_length*sizeof (void *), TM_width,
                   win->sprSavePtr, (2*win->frame+win->csizeX)*sizeof (void *),
                   (2*win->frame+win->csizeX)*sizeof (void *),
                   win->csizeY+2*win->frame);
  }
}

void WIN_show (TWIN *win)
{
  int subw;
  int i=0;
//  WIN_RedrawFrame (win);
  WIN_printContent (win, win->contentStart);

  while ((subw = AL_findNum ((long *)win->subWin, i, MAX_SUBWIN)) != -1)
  {
    WIN_show (win->subWin [subw]);
//    WIN_updateHumble (win->subWin [subw],1);
    i++;
  }

}/////////////////////////////////////////////


void WIN_close (TWIN *win)
{
  int i,subw;

  if (win != NULL)
  {
    i = 0;
    while ((subw = AL_findNum ((long *)win->subWin, i, MAX_SUBWIN)) != -1)
    {
      WIN_close (win->subWin [subw]);
      i++;
    }

    i = AL_find ((long *)WIN_openList, (long)win, MAX_OPENED);
    if (i != -1)
    {
      WIN_openList [i] = 0;
    }
    WIN_hide (win);
    _free (win->videoBuf);
    _free (win->saveBuf);
    win->videoBuf = NULL;
    win->saveBuf = NULL;
  }
}


void WIN_closeAll ()
{
  int i;

  for (i = 0; i < MAX_OPENED; i++)
  {
    WIN_close (WIN_openList [i]);
  }
}

void WIN_moreMiniHelp (TWIN *win)
{
  char **help;
  help = (win->miniHelp != NULL) ? win->miniHelp : WIN_defaultMiniHelp;
  if (help [win->curMiniHelp+1] != NULL)
    win->curMiniHelp++;
  else
    win->curMiniHelp = 0;
}



void WIN_printMiniHelp (TWIN *win)
{
  if (WIN_miniHelp != 0)
  {
    WIN_cls (WIN_miniHelp);
    if (win->miniHelp != 0)
    {
      WIN_puts (WIN_miniHelp, 0, 0, win->miniHelp [win->curMiniHelp], WIN_miniHelp->color.content);
    }
    else
    {
      if (WIN_defaultMiniHelp != 0)
      {
        WIN_puts (WIN_miniHelp, 0, 0, WIN_defaultMiniHelp [win->curMiniHelp], WIN_miniHelp->color.content);
      }
    }
  }
}



int WIN_open (TWIN *win)
{
  int i,subw;

  if (win != NULL)
  {
    i = AL_find ((long *)WIN_openList, 0, MAX_OPENED);
    if (i != -1)
    {
      win->videoBufSize = 2*(win->csizeX+4*win->frame)*(win->csizeY+3*win->frame);

      if (win->videoBuf == NULL)
      {
        win->videoBuf = (char *) _calloc (win->videoBufSize, 1, NULL);
        if (win->videoBuf == NULL)
          return -1;
      }

      if (win->saveBuf == NULL)
      {
        win->saveBuf = (char *) _calloc (win->videoBufSize, 1, NULL);
        if (win->saveBuf == NULL)
        {
          return -1;
        }
      }

      WIN_openList [i] = win;

      WIN_getRect (win);
      if (win->sprPtr)
      {
        LIN_get (sprPtr, (win->x)*sizeof (void *), (win->y),
                    TM_length*sizeof (void *), TM_width,
                    win->sprSavePtr,
                    (2*win->frame+win->csizeX)*sizeof (void *),
                    (2*win->frame+win->csizeX)*sizeof (void *),
                    win->csizeY+2*win->frame);
      }

      WIN_printContent (win, win->contentStart);

      i = 0;
      while ((subw = AL_findNum ((long *)win->subWin, i, MAX_SUBWIN)) != -1)
      {
        WIN_open (win->subWin [subw]);
        WIN_updateHumble (win->subWin [subw],1);
        i++;
      }
    }
    else
      return -1;
  }
  else
  {
    return -1;
  }
  return 0;
}

void WIN_openActive (TWIN *win)
{
  WIN_setActiveFrame (win);
  WIN_open (win);
}

void WIN_openPassive (TWIN *win)
{
  WIN_setPassiveFrame (win);
  WIN_open (win);
}

void WIN_openNoneFrame (TWIN *win)
{
  WIN_setNoneFrame (win);
  WIN_open (win);
}

void WIN_printMiniStatus (char *desc)
{
  if (desc != NULL)
  {
    WIN_cls (WIN_miniStatus);
    WIN_puts (WIN_miniStatus, 0, 0, desc, WIN_miniStatus->color.content);
  }
}



static void WIN_skipNonActiveUp (TWIN *win)
{
  while ((win->content [win->contentCur]. type == WIN_ITEMT_COMMENT) && (win->contentCur > 0))
    win->contentCur--;
  while (win->content [win->contentCur].type == WIN_ITEMT_COMMENT)
    win->contentCur++;
}

static void WIN_skipNonActiveDn (TWIN *win)
{
  while ((win->content [win->contentCur]. type == WIN_ITEMT_COMMENT) && (win->contentCur < win->contentCount-1))
    win->contentCur++;
  while (win->content [win->contentCur]. type == WIN_ITEMT_COMMENT)
    win->contentCur--;
}


void WIN_scrollUp (TWIN *win)
{
  if (win->selectable)
  {
    if (win->contentCur > 0)
    {
      if (win->contentCur == win->contentStart)
      {
        win->contentStart--;
      }
      win->contentCur--;
    }
    WIN_skipNonActiveUp (win);
  }
}

void WIN_scrollDn (TWIN *win)
{
  if (win->selectable)
  {
    if (win->contentCur < (win->contentCount-1)) // KEY DOWN
    {
      if ( (win->contentStart + win->csizeY -1) == win->contentCur)
      {
        win->contentStart++;
      }
      win->contentCur++;
    }
    WIN_skipNonActiveDn (win);
  }
}

void WIN_scrollHome (TWIN *win)
{
  win->contentCur = 0;
  win->contentStart = 0;
  WIN_skipNonActiveDn (win);
}

void WIN_scrollEnd (TWIN *win)
{
  if (win->contentCount > win->csizeY)
  {
    win->contentStart = win->contentCount - win->csizeY;
  }
  else
  {
    win->contentStart = 0;
  }

  win->contentCur = win->contentCount-1;
  WIN_skipNonActiveUp (win);
}


void WIN_scrollPageUp (TWIN *win)
{
  if ((win->contentCur == win->contentStart) || (!win->selectable))
  {
    if (win->contentStart > win->csizeY)
    {
      win->contentCur -= win->csizeY;
      win->contentStart -= win->csizeY;
    }
    else
    {
      WIN_scrollHome (win);
    }
  }
  else
  {
    win->contentCur = win->contentStart;
  }
  WIN_skipNonActiveUp (win);
}

void WIN_scrollPageDn (TWIN *win)
{
  if ( ((win->contentStart + win->csizeY-1) == win->contentCur) || (!win->selectable))
  {
    if ((win->contentCount - win->contentCur) > (win->csizeY)) // -1
    {
      win->contentCur += win->csizeY;
      win->contentStart += win->csizeY;
    }
    else
    {
      WIN_scrollEnd (win);
    }
  }
  else
  {
    if (win->contentCount > win->csizeY)
    {
      win->contentCur = win->contentStart + win->csizeY -1;
    }
    else
    {
      WIN_scrollEnd (win);
    }
  }
  WIN_skipNonActiveDn (win);
}


TWIN *WIN_subWin (TWIN *win)
{
  TWIN *subWinActive;

  if (win->subWinActive != -1)
  {
    subWinActive = win->subWin [win->subWinActive];
    if (subWinActive == NULL)
    {
      subWinActive = win;
    }
  }
  else
  {
    subWinActive = win;
  }
  return subWinActive;
}

void WIN_nextSubWin (TWIN *win)
{
  if (win->subWin)
  {
    do
    {
      win->subWinActive++;
      if (win->subWin [win->subWinActive] == NULL)
      {
        win->subWinActive = 0;
      }
    }
    while (!win->subWin [win->subWinActive]->selectable);
  }
}

void WIN_previousSubWin (TWIN *win)
{
  do
  {
    if (win->subWinActive == 0)
    {
      while (win->subWin [win->subWinActive+1] != NULL)
	win->subWinActive++;
    }
    else
    {
      win->subWinActive--;
    }
  }
  while (!win->subWin [win->subWinActive]->selectable);
}



int WIN_insert (TWIN *win)
{
  int redraw = -1;
  int exitcode;
  int c;
  int CTypee = TM_getCursorType ();
  int cx, cy;
  int contentCur;
  TWIN *callerWin,*oldActive;
  TWIN *subWin;
  TWIN *subWinActive;

  if (win != NULL)
  {
    callerWin = WIN_active;

    TM_getCursorPos (&cx, &cy);
    TM_setCursorType (TM_NOCURSOR);


    WIN_printMiniHelp (win);
  //  WIN_show (win);
//    WIN_updateHumble (WIN_subWin (win));
    WIN_active = WIN_subWin (win);

    if (win->frame)
    {
      WIN_setActiveFrame (win);
      WIN_redrawFrame (win);
    }
    else
    {
      if (WIN_active->frame)
      {
	WIN_setActiveFrame (WIN_active);
	WIN_redrawFrame (WIN_active);
      }
    }

    exitcode = 0;
    do
    {
//      oldActive = WIN_active;


      contentCur = WIN_active->contentCur;

      if ( (redraw != contentCur) || (oldActive != WIN_active))
      {
        WIN_show (WIN_active);
        WIN_redrawScreen ();
	redraw = contentCur;
        oldActive = WIN_active;
      }

      c = 0;

      if (WIN_active->content [contentCur].type == WIN_ITEMT_INPUT2)
      {
        c = WIN_input (win);
        if (c == 0)
          continue;
      }

      if (c == 0)
      {
//      WIN_redrawScreen ();
	c = WIN_waitEvent (win);
			contentCur = WIN_active->contentCur;
      }

      WIN_moveEvent (WIN_active, c);

      switch (c)
      {
        case KEY__ABORT:
        {
          exitcode = -1;
          break;
	}
        case KEY_DEL:
        {
          if ((WIN_active->commsAvail.del) && (WIN_active->selectable))
          {
            exitcode = WIN_COM_DEL;
          }
          break;
        }

	case KEY_F10:
        {
          if (WIN_active->commsAvail.f10)
	  {
            exitcode = WIN_COM_EXIT;
          }
          break;
        }

        case KEY_INS:
        {
          if ((WIN_active->commsAvail.ins) && (WIN_active->selectable))
          {
            exitcode = WIN_COM_INS;
          }
          break;
        }

        case MOUSE_SELECTITEM:
	{
          break;
        }

        case MOUSE_PUSHBUTTON:
        case KEY_ENTER:
	{
          if ((WIN_active->commsAvail.enter) && (WIN_active->selectable))
          {
            WIN_updateHumble (WIN_active,1);
            // update humble Win
            switch (WIN_active->content [contentCur].type)
            {
              case WIN_ITEMT_INPUT:
              {
		strcpy (WIN_active->content [contentCur].item, "");
                WIN_input (WIN_active);

                // read the input from keyboard, do not break
		break;
              }
              case WIN_ITEMT_CHECKBOX:
              {
                WIN_active->content [contentCur].curPos =
                  !WIN_active->content [contentCur].curPos;
                redraw = -1;
                break;
              }
	      case WIN_ITEMT_INPUT2:
              {
                exitcode = WIN_COM_ENTER;
                break;
              }
              case WIN_ITEMT_BUTTON:
              case WIN_ITEMT_MENU:
              case WIN_ITEMT_LIST:
              {
                exitcode = WIN_COM_ENTER;
		break;
              }
            }
	  }
	  break;
	}

	case MOUSE_RIGHTBUTTON:
	case KEY_ESC:
	{
	  if ((WIN_active->commsAvail.esc) && (WIN_active->selectable))
	  {
	    exitcode = WIN_COM_ESC;
	  }
	  break;
	}

	case KEY_TAB:
	{
	  WIN_waitHandler ();

	  if (!KEYB_shift)
	  {
            WIN_nextSubWin (win);
            WIN_changeActive (win, win->subWin [win->subWinActive] );
            WIN_redrawScreen ();
            redraw = -1;

            break;
	  }
	  else
	  {
	    WIN_previousSubWin (win);;
            WIN_changeActive (win, win->subWin [win->subWinActive] );
            WIN_redrawScreen ();
	    redraw = -1;

	    break;
	  }
	}
	case KEY_F1:
	{
	  WIN_moreMiniHelp (win);
	  WIN_printMiniHelp (win);
	  WIN_redrawScreen ();
	  break;
	}
      }
    }
    while (!exitcode);

    if (win->frame)
    {
      WIN_setPassiveFrame (win);
    }
    else
    {
      WIN_changeActive (NULL, win);
///      WIN_redrawScreen (); ///
    }

    WIN_show (win);

    TM_setCursorType (CTypee);
    TM_setCursorPos (cx, cy);
    WIN_active = callerWin;

    if (WIN_active->frame)
      WIN_setActiveFrame (WIN_active);

    WIN_redrawFrame (WIN_active);

    return exitcode;
  }
  return -1;
}

int WIN_exec (TWIN *win)
{
  int Com;

  if (win->frame)
    WIN_setActiveFrame (win);

  WIN_open (win);
  Com = WIN_insert (win);
  WIN_close (win);
  return Com;
}



void WIN_setMiniStatusWin (TWIN *win)
{
  WIN_miniStatus = win;
  WIN_openNoneFrame (win);
}

void WIN_setMiniHelpString (TWIN *win, char **str)
{
  if (win != NULL)
  {
    win->miniHelp = str;
    win->curMiniHelp = 0;
  }
}

void WIN_setMiniHelpWin (TWIN *win)
{
  WIN_miniHelp = win;
  WIN_openNoneFrame (win);
}

void WIN_setDefaultMiniHelp (char **defMiniHelp)
{
  WIN_defaultMiniHelp = defMiniHelp;
}

void WIN_deleteContent (TWIN *win)
{
  memset (win->content, 0, sizeof (TWINItem)*win->contentMax);
  win->contentCount = 0;
}


TWIN *WIN_new (int contentMax, int frame)
{
  TWIN *win;

  win = new TWIN;
  if (win != 0)
  {
    memset (win, 0, sizeof (TWIN));
    if (frame)
      WIN_setPassiveFrame (win);
    win->owner = NULL;
    win->contentMax = contentMax;
    win->content = new TWINItem [contentMax];
    win->contentCur = 0;
    win->frame = frame;
    win->shadow = 1;
    win->selectable = 1;
    win->commsAvail.enter = 1;
    win->commsAvail.f10 = 1;
    win->commsAvail.esc = 1;
    win->BGChar = ' ';
    win->sprSavePtr = NULL;
    win->sprBuf = NULL;
    win->sprPtr = NULL;

    strcpy (win->title, "");
    if (win->content == 0)
    {
      delete win;
      return NULL;
    }
    WIN_deleteContent (win);
    return win;
  }
  return NULL;
}


void WIN_setSpr (TWIN *win, TCSF *spr)
{
  int  i,j;
  int  sizeX;
  int  sizeY;
  long offset;
  long size;
  int  ssizeX;
  int  ssizeY;
  int  ssize;
  int  csizeX;
  int  csizeY;
  int  csize;
  int  x,y;

  if (spr != NULL)
  {
    csizeX = spr->sizeX / TM_clength;
    csizeY = spr->sizeY / TM_cwidth;
    csize  = csizeX * csizeY;
    ssizeX = csizeX * TM_clength;
    ssizeY = csizeY * TM_cwidth;
    ssize = ssizeX * ssizeY;
    sizeX = win->csizeX+win->frame+win->frame;
    sizeY = win->csizeY+win->frame+win->frame;
    size = sizeX*sizeY;

    win->sprPtr = (void * *) _calloc (size,sizeof (void *), NULL);
    if (win->sprPtr != NULL)
    {
      win->sprSavePtr = (void * *) _calloc (size,sizeof (void *), NULL);
      if (win->sprSavePtr != NULL)
      {
        win->sprBuf = (char *) _alloc (ssize);
        if (win->sprBuf != NULL)
        {
          offset = 0;
          for (j = 0; j < ssizeY; j+=TM_cwidth)
          {
            for (i = 0; i < ssizeX; i += TM_clength)
            {

              LIN_get (spr->raw, i, j, spr->sizeX, spr->sizeY,
                          win->sprBuf+offset, TM_clength, TM_clength, TM_cwidth);
              offset += TM_csize;
            }
          }

          offset = 0;
          y = 0;
          for (j = 0; j < sizeY; j++)
          {
            x = 0;
            for (i = 0; i < sizeX; i++)
            {
              win->sprPtr [offset] = win->sprBuf+TM_csize*(x + y);
              offset++;

              x++;
              if (x == csizeX)
              {
                x = 0;
              }
            }
            y += csizeX;
            if (y == csize)
            {
              y = 0;
            }
          }
        }
        else
        {
          _free (win->sprSavePtr);
          win->sprSavePtr = NULL;
          _free (win->sprPtr);
          win->sprPtr = NULL;
          _free (win->sprBuf);
          win->sprBuf = NULL;
        }
      }
      else
      {
        _free (win->sprSavePtr);
        win->sprSavePtr = NULL;
        _free (win->sprPtr);
        win->sprPtr = NULL;
      }
    }
    else
    {
      _free (win->sprPtr);
      win->sprPtr = NULL;
    }
  }
}


int WIN_newViewer (TWIN *win, char *FileName, char *miniStatus)
{
  char FBuf [ITEM_SIZE];
  char *S;
  FILE *VFile;
  int I;

  if ((VFile = fopen (FileName, "rt")) == NULL)
    return -1;

  for (I = 0; I < win->contentMax && (fgets (FBuf, ITEM_SIZE-1, VFile) != NULL); I++)
  {
//    S = strchr (FBuf, 0x0A);
//    if (S != NULL)
//    {
//      *S = '\n';
//      *++S = 0;
//    }
    WIN_appendMenu (win, "", FBuf, -1, miniStatus, -1);
  }

  fclose (VFile);

  return 0;
}


void WIN_setDesktop (char backGround, char color, TCSF *spr)
{
  WIN_desktop = WIN_new (0, WIN_NONEFRAME);
  WIN_setNoneFrame (WIN_desktop);
  WIN_setBounds (WIN_desktop, 0, 0, TM_length, TM_width);
  WIN_setColors (WIN_desktop, color, -1, -1, -1, -1, -1, -1);
  WIN_desktop->BGChar = backGround;
  WIN_setNoneFrame (WIN_desktop);
  WIN_setSpr (WIN_desktop, spr);
  WIN_open (WIN_desktop);
}


int WIN_getValue (TWIN *win, int content)
{
  return win->content [content].value;
}

TWINItem *WIN_item (TWIN *win, int item)
{
  if (item == -1)
    return NULL;
  else
    return win->content+item;
}

void WIN_setHumble (TWIN *win, TWIN *humbleWin, int item)
{
  if (win != NULL)
  {
    win->humbleWin = humbleWin;
    win->humbleItem = item;
  }
}

long WIN_value (TWIN *win)
{
  return win->content [win->contentCur].value;
}

char *WIN_itemStr (TWIN *win)
{
  return win->content [win->contentCur].item;
}


TWIN *WIN_newWinButton (char *desc, int value)
{
  TWIN *win;

  win = WIN_new (1, WIN_NONEFRAME);
  WIN_setNoneFrame (win);
  WIN_appendButton (win, "", desc, value, NULL, -1);
  WIN_setBounds (win, 0, 0, strlen (desc), 1);

  return win;
}

char WIN_waitKey (TWIN *win)
{
  char c;

  WIN_open (win);
  WIN_redrawScreen ();

  do
  {
    c = KEYB_get ();
    if (!c)
    {
      c = WIN_waitHandler ();
//    SVGA_update (1);
    }
  }
  while ((!c) && (!MOUSE_info.buttons.right))
    ;

  while (MOUSE_info.buttons.right)
  {
    c = WIN_waitHandler ();
    if (c)
      break;
//    SVGA_update (1);
  }

  WIN_close (win);

  return c;
}
